#!/usr/bin/env python
#  usage:
#    ./bomhelp.py
#  pretty prints BOM5 keyword documentation found in setup2.f90
#  usage tip: I have the following alias in my ~/.bashrc
#    alias bomhelp='cd $HOME/bom5 && bomhelp.py | less && cd -'
#  from any directory I can then inspect the doc in "less" with the command "bomhelp"

import string, os

f=open("setup2.f90","r")
l=f.readlines()
f.close()

active=0
gotacase=0
doc=""
keyword=""

keywords={}

for line in l:

    ## first time we hit this is the declaration, second the end.
    if line.find("subroutine parse_setup_line") > 0:
        active = not active

    ## if we are in the "active" region, ie parse_setup_line, check if
    ## we have a case statement on the line. if so, split the line to
    ## get the keyword, and flag "gotacase"
    if active and line.find("  case(") > 0:
        ls = string.split(line,"'")
        keyword = ls[1]
        gotacase=1

    stripline = line.strip()

    if len(stripline) > 0:
        ## if we recently got a case statement, and the first char on a
        ## stripped line is !, it is a comment, or in our case a doc line.
        ## append doc lines until first col is not !.
        if active and gotacase and stripline[0] == "!":
            if len(doc) > 0:                
                doc += "\n" + stripline[1:]
            else:
                doc = stripline[1:].upper()

        ## first col is not ! and doc has content, we are just done
        ## fetching comment lines. store doc with key, reset.
        if stripline[0] <> "!" and len(doc) > 0:
            gotacase=0
            keywords[keyword] = doc
            doc=""

liste = keywords.keys()
liste.sort()

for item in liste:
    print "\n" + keywords[item]
    
