subroutine dumpmask 
  !! dumps an ascii version of the grid to the file "grid.data" for inspection in a text editor.
  use state
  use control_parameters
  use mod_bound
  implicit none
  character point
  integer i,j,r
  real, allocatable :: gh(:,:)

  
  if(.not.dodumpmask) return

  if(master) then
      allocate(gh(gim,gjm))
      call gatherfield(h, gh, gim, gjm, 1)
  else
      allocate(gh(1,1))
      call gatherfield(h, gh, 1, 1, 1)      
  end if
  

  if(master)then      
      open(1000004,file='grid.data')

      write(1000004,'(a)') "-*- truncate-lines: t -*-"
      write(1000004,'(/,a,f0.1,/)') 'Max H=', maxval(h)
      write(1000004,'(a)')   '. water'
      write(1000004,'(a)')   '# land'
      write(1000004,'(a)')   'W point source (well)'  
      write(1000004,'(a)')   '1 river inlet west side of cell'
      write(1000004,'(a)')   '2 river inlet south side of cell'
      write(1000004,'(a)')   '3 river inlet east side of cell'
      write(1000004,'(a)')   '4 river inlet north side of cell'  
      write(1000004,'(a)')   '+ 10x10 grid vertex in water'
      write(1000004,'(a,/)') '* 10x10 grid vertex on land'   

      do j=jm,1,-1
          do i=1,im          
              if(gh(i,j) > 0.0001) then
                  point = '.'
              else
                  point = '#'
              end if

              if(bltab(gi2block(i),gj2block(j))%wet == 0) point=" "
              
              if(mod(j,10)==0)then
                  if(i==1) write(1000004,'(i4,1x,"-")', advance='no') j              
                  if(mod(i,10)==0) then
                      if(gh(i,j) > 0.0001) then
                          point = '+'
                      else
                          point = '*'
                      end if
                  end if
              else
                  if(i==1) write(1000004,'(6x)', advance='no')
              end if

              do r=1,numc
                  if(i==iriver(r) .and. j==jriver(r)) then
                      select case(coderiver(r))
                      case(1)
                          point="1"
                      case(2)
                          point="2"
                      case(3)
                          point="3"
                      case(4)
                          point="4"
                      end select
                  end if
              end do

              do r=1,numwell
                  if(i==iwell(r) .and. j==jwell(r)) then
                      point = "W"
                  end if
              end do

              write(1000004,'(a1)', advance='no') point
          end do
          write(1000004,*)
      end do

      j=1
      write(1000004,'(6x)', advance='no')
      do i=1,im
          if(mod(i,10) == 0) then
              write(1000004,'(a)', advance='no') '|'
          else
              write(1000004,'(1x)', advance='no')
          end if
      end do
      write(1000004,'(/,3x)', advance='no')

      i=0
      do
          i=i+1
          if(i>im) exit
          if(mod(i,10) == 0) then
              write(1000004,'(i4)', advance='no') i
              i=i+3
          else
              write(1000004,'(1x)', advance='no')
          end if
      end do
      write(1000004,*)
      close(1000004)
  end if

  deallocate(gh)
end subroutine dumpmask
