!  subroutine expprofile(f, fmax, fmin, deltaz, r)
!    implicit none
!   integer, parameter :: localkind=...  
    real(localkind) f(1-ghost_wi:,1-ghost_wj:,:)
    real(localkind) :: fmax, fmin, deltaz
    integer, optional :: r(:)
    integer k,i,j,is,ie,js,je,ks,ke, lis,lie,ljs,lje
    real dep
    logical inblock

    if(.not.z_set) then
        call message('sigma layers must be initialized before you do code 6 operations!',2)
    end if

    ks=1  ;  ke=gkb  ;  js=1  ;  je=gjm ;  is=1  ;  ie=gim
    if(present(r)) then
        is=r(1)  ;  ie=r(2)  ;  js=r(3)  ;  je=r(4) ;  ks=r(5) ;  ke=r(6)
    end if

    if(master.and.debug>0) then
        write(*,*)' Stratification from EXP profile:'
        write(*,*)' Depth, value for H=DEPMAX=', depmax
        do k = ks,ke
            if (k<kb) then
                dep = zz(k)*depmax
                write(*,*) dep, fmax - (fmax-fmin)*exp(dep/deltaz)
            end if
        end do
        write(*,*)
    end if

    call  globalrect2local(is,ie,js,je,lis,lie,ljs,lje,inblock)

    if(inblock) then
        do k = ks,ke
            do j = ljs,lje
                do i = lis,lie
                    if (h(i,j) > 0.00001 .and. k<kb) then
                        dep = zz(k)*h(i,j)
                        f(i,j,k) = fmax - (fmax-fmin)*exp(dep/deltaz)
                    end if
                end do
            end do
        end do
    end if
!  end subroutine expprofile
