!  subroutine getfield_2dr4(f, name)
!    implicit none
!    real(4), allocatable :: f(:,:)
    integer :: assertdimension=1
    character(*) name
    integer i,j,dim(10),type

    dim = getdimension(name,assertdimension)
    type = gettype(name)
    call genopen(99, name, type)

    if(.not.allocated(f))then
        if(dim(1)==0)then
            write(*,*) "getfield error: target field not allocated and unable to detect field size from file name"
        else
         ! target not allocated, assume file name has right dimension
            print *,'getfield: allocating target array with dimension ',dim(2:)
            allocate(f(dim(2)))
        end if
    else
      ! target is allocated, but no dimension in file name, assume allocated size is ok:
        if(dim(1) == 0) then
            dim(2) = size(f,1)
        else
      ! target is allocated, check dimension. if not right, trust the file name, and reallocate.            
            if(dim(2) .ne. size(f,1)) then
                deallocate(f)
                allocate(f(dim(2)))
            end if
        end if
    end if
    
    select case(type)    
    case(1,2)
        read(99,err=101,end=101) f
    case default
        do i=1,dim(2)
            read(99,*,err=101,end=101) f(i)
        end do
    end select
    close(99)
    return
101 call message("filereader getfield: error reading binary 1d array from file. wrong dimensions?",2)
102 call message("filereader getfield: error reading 1d array from ascii file. wrong dimensions?",2)
!end subroutine
