!  subroutine getfield_3dr4(f, name)
!    implicit none
!    real(4), allocatable :: f(:,:,:)
    integer :: assertdimension=3
    character(*) name
    integer i,j,k,dim(10),type

    dim = getdimension(name,assertdimension)
    type = gettype(name)
    call genopen(99, name, type)

    if(.not.allocated(f))then
        if(dim(1)==0)then
            write(*,*) "getfield error: target field not allocated and unable to detect field size from file name"
        else
         ! target not allocated, assume file name has right dimension
            print *,'getfield: allocating target array with dimension ',dim(2:)
            allocate(f(dim(2),dim(3),dim(4)))
        end if
    else
      ! target is allocated, but no dimension in file name, assume allocated size is ok:
        if(dim(1) == 0) then
            dim(2) = size(f,1)
            dim(3) = size(f,2)
            dim(4) = size(f,3)
        else
      ! target is allocated, check dimension. if not right, trust the file name, and reallocate.
            if(dim(2) .ne. size(f,1) .or. dim(3) .ne. size(f,2) .or. dim(3) .ne. size(f,3)) then
                deallocate(f)
                allocate(f(dim(2),dim(3),dim(4)))
            end if
        end if
    end if
    
    select case(type)    
    case(1,2)
        read(99,err=101,end=101) f
    case default
        do k=1,dim(4)
            do j=1,dim(3)
                do i=1,dim(2)
                    read(99,*,err=102,end=102) f(i,j,k)
                end do
            end do
        end do
    end select
    close(99)
    return
101 call message("filereader getfield: error reading binary 3d array from file. wrong dimensions?",2)
102 call message("filereader getfield: error reading 3d array from ascii file. wrong dimensions?",2)
!end subroutine
