! the body of subroutine get1dfields. since the only difference
! between the real8 and real4 version is the kind, include the body in
! order to have one copy of the code.

!  subroutine get_1d_fields4(file, col1, col2, col3, col4, col5, col6, col7, col8, cols, lines, file_region, file_shape,ierr)
!   implicit none

    character(*) file
    real(localkind), dimension(:) :: col1
    real(localkind), optional, dimension(:) :: col2,col3,col4,col5,col6,col7,col8
    integer, optional :: file_region(4), file_shape(2), cols(:), lines, ierr
    integer i,n,idim,i1,i2,ind
    integer f(8),s(1), m,c
    real(localkind) tmp(8)
    logical usecols

    if(present(ierr)) ierr=0
    
!! find the minimum number of columns "n" we got to read, and get the
!! size of each provided field f, as well as the shape s. s is the
!! shape of the last field checked. all shapes should be the same, 
!! error otherwise. also count the number of provided colX's in m.
    n=0
    f = 0
    s = 0
    m=0
    call check_args(col1, 1, f, n, s, m)    
    if(present(col2)) call check_args(col2, 2, f, n, s, m)
    if(present(col3)) call check_args(col3, 3, f, n, s, m)
    if(present(col4)) call check_args(col4, 4, f, n, s, m)
    if(present(col5)) call check_args(col5, 5, f, n, s, m)
    if(present(col6)) call check_args(col6, 6, f, n, s, m)
    if(present(col7)) call check_args(col7, 7, f, n, s, m)
    if(present(col8)) call check_args(col8, 8, f, n, s, m)

    usecols=.false.
    if(present(cols)) then
        usecols=.true.
        if(size(cols) .ne. m) then
            write(*,*)'get_1d_fields error: the number of provided fields is different from the number of requested fields'
            stop
        end if
        n = maxval(cols)
    end if
    
    if(present(file_region) .or. present(file_shape)) then
!! the number of lines given by file shape
        if(.not. (present(file_region) .and. present(file_shape))) then
            write(*,*)'get_1d_fields error, both region and shape must be given, not only one'
            stop
        end if
        idim = file_shape(1)
        i1=file_region(1)
        i2=file_region(2)
        if(i1 < 1 .or. i2>idim) then
            write(*,*)'get_1d_fields error: specified region=',file_region,' does not fit with file shape=',file_shape
            stop
        end if
    else
!! the biggest field is the number of lines that has to be present in the file.
        idim = maxval(f)
        i1=1
        i2=idim
    end if
    
!! Sanity checks   
    
    if(n==0 .or. maxval(f)<1) then
        write(*,*)'get_1d_fields error, no fields with space provided to read data from',trim(file)
        stop
    end if 
    
!! then we can start actually reading data...
    
    open(1000003, file=file, status='old', action='read', err=103)

    ! loop over the assumed number of lines in the file
    do i=1,idim
        read(1000003,*, end=101, err=102) tmp(1:n)
        
        if(i >= i1 .and. i <= i2) then
            
! we're in the desired range, ind points into the field, which is why
! it starts from 1            
            ind = i - i1 + 1
            
            if(usecols) then
! ok, use the cols array to override which fields to fetch from. cols
! is a list of columns to assign to fields.  we don't know which
! fields are provided in the argument list, so we gotta check them
! all, and increment c, the pointer into cols, each time we find an
! array to assign to (f(i)>0 says that an array is present and has a size)
                c=0
                if(f(1) > 0) call assigntocol(col1,c)
                if(f(2) > 0) call assigntocol(col2,c)
                if(f(3) > 0) call assigntocol(col3,c)
                if(f(4) > 0) call assigntocol(col4,c)
                if(f(5) > 0) call assigntocol(col5,c)
                if(f(6) > 0) call assigntocol(col6,c)
                if(f(7) > 0) call assigntocol(col7,c)
                if(f(8) > 0) call assigntocol(col8,c)
            else
! easier&faster, each colX corresponds directly to a column in the file to
! save an if we may want to skip this method, as it is not likely to
! be used from setup. leave it for now.
                if(f(1) > 0) col1(ind) = tmp(1)
                if(f(2) > 0) col2(ind) = tmp(2)
                if(f(3) > 0) col3(ind) = tmp(3)
                if(f(4) > 0) col4(ind) = tmp(4)
                if(f(5) > 0) col5(ind) = tmp(5)
                if(f(6) > 0) col6(ind) = tmp(6)
                if(f(7) > 0) col7(ind) = tmp(7)
                if(f(8) > 0) col8(ind) = tmp(8)
            end if
        end if
    end do
    
    close(1000003)
    return
    
101 if(present(lines)) lines = i-1
    close(1000003)
    return
102 write(*,*)'get_1d_fields error: while reading n=',n,' variables from line',i,'of file',trim(file),'lines=',maxval(f)
    close(1000003)
    if(present(ierr)) then
        ierr=1
        return
    else
        stop
    end if
103 write(*,'(2a)')'get_1d_fields error: could not open file ',trim(file)
    if(present(ierr))then
        ierr=2
        return
    else
        stop
    end if
    
  contains
    
    subroutine assigntocol(field, ci)
      real(localkind) field(:)
      integer ci
      ci = ci+1      
      field(ind) = tmp(cols(ci))
    end subroutine
    
! end subroutine
