! the body of subroutine get3dfields. since the only difference
! between the real8 and real4 version is the kind, include the body in
! order to have one copy of the code.
!
!  subroutine get_3d_fields4(file, col1, col2, col3, col4, col5, col6, col7, col8, cols, file_region, file_shape, ierr)
!
    character(*) file
    real(localkind), dimension(:,:,:) :: col1
    real(localkind), optional, dimension(:,:,:) :: col2,col3,col4,col5,col6,col7,col8
    integer, optional :: file_region(6), file_shape(3), cols(:), ierr
    integer i,j,k,n,idim,jdim,kdim,i1,i2,ind,j1,j2,indj, k1,k2, indk
    integer f(8),s(3),m,c
    real(localkind) tmp(8)
    logical usecols
    
!! find the minimum number of columns "n" we got to read, and get the
!! size of each provided field f, as well as the shape s. s is the
!! shape of the last field checked. all shapes should be the same,
!! error otherwise:
    n=0
    f = 0
    s = 0
    m=0
    call check_args(col1, 1, f, n, s, m)    
    if(present(col2)) call check_args(col2, 2, f, n, s, m)
    if(present(col3)) call check_args(col3, 3, f, n, s, m)
    if(present(col4)) call check_args(col4, 4, f, n, s, m)
    if(present(col5)) call check_args(col5, 5, f, n, s, m)
    if(present(col6)) call check_args(col6, 6, f, n, s, m)
    if(present(col7)) call check_args(col7, 7, f, n, s, m)
    if(present(col8)) call check_args(col8, 8, f, n, s, m)

    usecols=.false.
    if(present(cols)) then
        usecols=.true.
        n = maxval(cols)
        if(size(cols) .ne. m) then
            write(*,*)'get_3d_fields error: the number of provided fields is different from the number of requested fields'
        end if
    end if

    if(present(file_region) .or. present(file_shape)) then
!! the number of lines given by file shape
        if(.not. (present(file_region) .and. present(file_shape))) then
            write(*,*)'get_3d_fields error, both region and shape must be given, not only one'
            stop
        end if
        idim = file_shape(1)
        jdim = file_shape(2)
        kdim = file_shape(3)
        i1=file_region(1)
        i2=file_region(2)
        j1=file_region(3)
        j2=file_region(4)
        k1=file_region(5)
        k2=file_region(6)
        if(i1 < 1 .or. i2>idim .or. j1<1 .or. j2>jdim .or. k1<1 .or. k2>kdim) then
            write(*,*)'get_3d_fields error: specified region=',file_region,' does not fit with file shape=',file_shape
            stop
        end if
        if( i2-i1+1 > s(1) .or. j2-j1+1 > s(2) .or. k2-k1+1 > s(3)) then
            write(*,*)'get_3d_fields error: the file region is bigger than the provided array'
            stop
        end if
    else
!! the biggest field is the number of lines that has to be present in the file.
        idim=s(1)
        jdim=s(2)
        kdim=s(3)
        i1=1
        i2=s(1)
        j1=1
        j2=s(2)
        k1=1
        k2=s(3)
    end if
    
!! Sanity checks   
    
    if(n == 0 .or. maxval(f) < 1) then
        write(*,*)'get_3d_fields error, no fields with space provided to read data from',trim(file)
        stop
    end if 
    
!! then we can start actually reading data...
    
    open(1000003, file=file, status='old', action='read', err=103)

    do k=1,kdim
     do j=1,jdim
      do i=1,idim
             
        read(1000003,*, end=101, err=102) tmp(1:n)
        
        if(i >= i1 .and. i <= i2 .and. j>=j1 .and. j<=j2 .and. k>=k1 .and. k<=k2) then
            ind = i - i1 + 1
            indj= j - j1 + 1
            indk= k - k1 + 1

            if(usecols) then
                c=0
                if(f(1) > 0) call assigntocol(col1,c)
                if(f(2) > 0) call assigntocol(col2,c)
                if(f(3) > 0) call assigntocol(col3,c)
                if(f(4) > 0) call assigntocol(col4,c)
                if(f(5) > 0) call assigntocol(col5,c)
                if(f(6) > 0) call assigntocol(col6,c)
                if(f(7) > 0) call assigntocol(col7,c)
                if(f(8) > 0) call assigntocol(col8,c)
            else
                if(f(1) > 0) col1(ind,indj,indk) = tmp(1)
                if(f(2) > 0) col2(ind,indj,indk) = tmp(2)
                if(f(3) > 0) col3(ind,indj,indk) = tmp(3)
                if(f(4) > 0) col4(ind,indj,indk) = tmp(4)
                if(f(5) > 0) col5(ind,indj,indk) = tmp(5)
                if(f(6) > 0) col6(ind,indj,indk) = tmp(6)
                if(f(7) > 0) col7(ind,indj,indk) = tmp(7)
                if(f(8) > 0) col8(ind,indj,indk) = tmp(8)
            end if
        end if
      end do
     end do
    end do
 
    close(1000003)
    return
    
101 write(*,*)'get_3d_fields error: reached end of line/file ',trim(file),' reading ',n,' columns, lines=',maxval(f)
    if(present(ierr)) then
        ierr=1
        return
    else
        stop
    end if

102 write(*,*)'get_3d_fields error: while reading n=',n,' variables from line',i,'of file',trim(file),'lines=',maxval(f)
    if(present(ierr)) then
        ierr=1
        return
    else
        stop
    end if

103 write(*,*)'get_3d_fields error: could not open file',trim(file)
    if(present(ierr)) then
        ierr=1
        return
    else
        stop
    end if

  contains
    subroutine assigntocol(field, ci)
      real(localkind) field(:,:,:)
      integer ci
      ci = ci+1
      field(ind,indj,indk) = tmp(cols(ci))
    end subroutine
!  end subroutine get_3d_fields4
