!  subroutine gip(fs, ft, m, method)
!    use mod_mpi, only : i1,j1,fci1,fci2,fcj1,fcj2
!    implicit none
!    integer, parameter :: localkind=4
    real(localkind) :: fs(:,:)
    real :: ft(i1:,j1:)
    type(mapping_object) m(i1:,j1:)
    character(*), optional :: method
    integer i,j,is,js,di,dj,choice

! trianglular interpolation by default   
    choice=1
    if(present(method))then
        if(method=="bilinear") choice=2
    end if

    select case(choice)
    case(1)
        do j=fcj1,fcj2
            do i=fci1,fci2
                if(m(i,j)%weight_type == 0) cycle            
                is = m(i,j)%i
                js = m(i,j)%j

            ! assume lower triangle. (correct half of the time)
                di = 1  ;  dj = 0            
                if(m(i,j)%weight_type == 2) then
                    di = 0 ; dj = 1
                end if
            
                ft(i,j) = m(i,j)%w(1)*fs(is,js) + m(i,j)%w(2)*fs(is+di,js+dj) + m(i,j)%w(3)*fs(is+1,js+1)
            end do
        end do
    case(2)
        do j=fcj1,fcj2
            do i=fci1,fci2
                if(m(i,j)%weight_type == 0) cycle
                is = m(i,j)%i
                js = m(i,j)%j
                ft(i,j) = m(i,j)%w(1)*fs(is,js) + m(i,j)%w(2)*fs(is+1,js) + m(i,j)%w(3)*fs(is+1,js+1) + m(i,j)%w(4)*fs(is,js+1)
            end do
        end do        
    end select
!  end subroutine gip
