! if you don't have and use netcdf, link in this file instead. it will
! not give netcdf support, but will enable linking without needing to
! comment out all calls to netcdf routines.

module netcdf  
  use qmpi

  integer, parameter :: nf90_noerr=0, nf90_ebadid=1, nf90_max_var_dims=5

  interface nf90_get_var
     module procedure nf90_get_var1dr4, nf90_get_var1dr8,nf90_get_var2d
  end interface
  
contains
  
  integer function nf90_open(file, mode, ncid)
    character(*) file
    integer, optional :: mode, ncid
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_open=0
  end function nf90_open

  integer function nf90_inq_varid(ncfile, name, varid)
    integer ncfile, varid
    character(*) name
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_inq_varid=0
  end function nf90_inq_varid

  integer function nf90_get_var1dr4(ncfile, varid, var, start, count)
    integer ncfile, varid
    integer, optional :: start(:), count(:)
    real(4) var(:)
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_get_var1dr4=0
  end function nf90_get_var1dr4

  integer function nf90_get_var1dr8(ncfile, varid, var, start, count)
    integer ncfile, varid
    integer, optional :: start(:), count(:)
    real(8) var(:)
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_get_var1dr8=0
  end function nf90_get_var1dr8
  
  integer function nf90_get_var2d(ncfile, varid, var, start, count)
    integer ncfile, varid
    integer, optional :: start(:), count(:)
    real var(:,:)
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_get_var2d=0
  end function nf90_get_var2d

  integer function nf90_close(ncfile)
    integer ncfile
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_close=0
  end function nf90_close

  integer function nf90_inquire_variable(ncfile, varid, dimids)
    integer ncfile, varid, dimids(:)
    call abort("ERROR, this is the dummy netcdf, if you need the real one, remove netcdf_dummy.f90 from the Makefile and recompile")
    nf90_inquire_variable=0
  end function nf90_inquire_variable

  integer function nf90_inquire_dimension(ncfile, dimid, name, len)
    integer ncfile, dimid, len
    character(*) name
    nf90_inquire_dimension=0
  end function nf90_inquire_dimension
  
end module netcdf
