SUBROUTINE NRG3D()
  USE STATE
  IMPLICIT NONE
  REAL(DP) DEKIN,DVOLUME,DMASS,DEETA  
  INTEGER I,J,K,DJ
!
!Compute Volume, Potental energy 
!
  DVOLUME=0.0_DP
  DEKIN=0.0_DP
  DMASS = 0.0_DP
  DEETA = 0.0_DP
  call tag_ghost( rho, west+south, 1 )
  call update_ghost
  

  DO J=1,J_EQ_JM
      DO I=1,I_EQ_IM
          IF (FSM(I,J).GT.0.) THEN
              DVOLUME = DVOLUME + real(D(I,J),dp)
              DEETA = DEETA + real(ETA(I,J),dp)*real(ETA(I,J),dp)
          END IF
      END DO
  END DO

  DJ=0
  IF(JM>1) DJ=1


  DO K = 1,KB-1
      DO J=J_EQ_2,J_EQ_JM
          DO I=I_EQ_2,I_EQ_IM
              IF (FSM(I,J).GT.0.) THEN  
                  DMASS = DMASS + (REAL(RHO(I,J,K),DP)&
                       +REAL(RHOAVER,DP)+1000.0_DP)*REAL(D(I,J),DP)*REAL(DZ(K),DP)
              ENDIF
              IF (DUM(I,J).GT.0.) THEN
                  DEKIN = DEKIN + 0.5_DP*(REAL(RHO(I,J,K),DP)+REAL(RHO(I-1,J,K),DP)&
                       +2.0_DP*REAL(RHOAVER,DP)+2000_DP)*REAL(DZ(K),DP)&
                       *REAL(DU(I,J),DP)*REAL(U(I,J,K),DP)*REAL(U(I,J,K),DP)
              ENDIF
              IF (DVM(I,J).GT.0.) THEN
                  DEKIN = DEKIN + 0.5_DP*(REAL(RHO(I,J,K),DP)+REAL(RHO(I,J-DJ,K),DP)&
                       +2_DP*REAL(RHOAVER,DP)+2000.0_DP)*REAL(DZ(K),DP)&
                       *REAL(DV(I,J),DP)*REAL(V(I,J,K),DP)*REAL(V(I,J,K),DP)
              ENDIF
          END DO
      END DO
  END DO

  call reduce('sum', dekin,dvolume,dmass,deeta )
  VOL =  REAL(DVOLUME)*DX*DY
  EKIN = REAL(DEKIN)*0.5*DX*DY/VOL
  MASS = DX*DY*REAL(DMASS)/VOL
  EETA = REAL(EETA)*0.5*GRAV*1025.*DX*DY/VOL
END SUBROUTINE NRG3D
