SUBROUTINE OUTPUT
  
!! not much left here, things are initialized in setup2.f90, these
!! wrappers iterates through lists of what to do, and then hopefully
!! do the right things.
  
  USE STATE
  USE TIMESERIES
  USE BOMPLOT
  USE MAXMIN
  USE PGPLOT
  USE MOD_TRANSPORT
  USE CONTROL_PARAMETERS, ONLY : CHECKPOINT_DIR, FIRST_STEP
  USE MOD_CRUISE
  USE MOD_AVERAGING
  IMPLICIT NONE

! first, calculate energy, mass or other diagnostics
  CALL NRG3D()

! calculate transports over vsect lines
  CALL GET_TRANSPORT()

! find and print max, min and location of selected arrays
  CALL DUMP_MAXMIN()
  
! dump selected fields to file in matlab/python/gnuplot etc friendly format
  CALL BATCH_BOMPLOT()

! sample selected time series to memory (disk later)
  CALL SAMPLE_TIMESERIES(ISTEP)

! go through list of cruises, dump to file at some interval (same as timeseries?)
  CALL SAMPLE_CRUISES(ISTEP)

! compute and dump time averages of selected sections/fields
  CALL COMPUTE_AVERAGES()
  
! plot to screen or graphics file during simulation with PGPLOT  
  CALL BATCH_PGPLOT

! dump timeseries to file in batches and reallocate storage to only keep some data in memory
  IF(ISTEP >= FIRST_STEP) CALL STORE_TIMESERIES(ISTEP, TRIM(CHECKPOINT_DIR))
  
  call dump_state('output')
END SUBROUTINE OUTPUT 
