!! PS this file should be include'd in mod_mpi, just after specifying
!! localkind, not meant as a stand alone file. interface included for reference.

!subroutine scatterfield(fglobal, flocal, im,jm,kb)
!
! distribute the field fglobal out to the cpu's given by structures in mod_mpi
! and return flocal, also including ghost zones, on each process.
!
!  implicit none
!  integer, parameter :: localkind=4
  real(localkind), intent(in) :: fglobal(:,:,:)  
  real(localkind), intent(out):: flocal(1-ghost_wi:,1-ghost_wj:,:)
  
!  real(localkind), allocatable :: sendbuf(full_i_blocksize*full_j_blocksize*gkb*numproc)
  real(localkind), allocatable :: sendbuf(:)
!  real(localkind) recvbuf(full_i_blocksize*full_j_blocksize*gkb)
  
  integer i,j, b_i,b_j, k, gi1,gi2,gj1,gj2, blocksize_3d, ind_sb, kdim

  kdim = size(flocal,3)
  allocate(sendbuf(full_i_blocksize*full_j_blocksize*kdim*numproc))
  
  if(numproc==1)then
      flocal(1:gim,1:gjm,1:kdim) = fglobal(1:gim,1:gjm,1:kdim)
      return
  end if
  
  blocksize_3d = full_i_blocksize * full_j_blocksize * kdim

  if(master) then
      do b_j=1,numblj
          do b_i=1,numbli
              
              ! the global range from which to fetch block data:
              gi1=bltab(b_i,b_j)%fi-ghost_wi
              gi2=gi1 + full_i_blocksize -1
              
              gj1=bltab(b_i,b_j)%fj-ghost_wj
              gj2=gj1 + full_j_blocksize -1
              
              if(bltab(b_i,b_j)%prn .ne. mpi_proc_null) then
                  
                  ind_sb= bltab(b_i,b_j)%prn * blocksize_3d + 1
                  
                  do k=1,kdim
                      do j=gj1,gj2
                          do i=gi1,gi2
                              
                              if(i>=1 .and. i<=gim .and. j>=1 .and. j<=gjm)then
                                  sendbuf(ind_sb)= fglobal(i,j,k)
                              else
                                  sendbuf(ind_sb)= 0.0
                              end if
                              
                              ind_sb=ind_sb + 1
                          end do
                      end do
                  end do
                  
              end if
              
          end do
      end do
  end if
! this normally works, if it doesnt use below lines.  
!  call mpi_scatter(sendbuf, blocksize_3d, MPI_REAL4, flocal, blocksize_3d, &
!       MPI_FLOAT_TYPE, 0, mpi_comm_world, ierr)

!  call mpi_scatter(sendbuf, blocksize_3d, mpi_REAL4, recvbuf, blocksize_3d, &
!       mpi_float_type, 0, mpi_comm_world, ierr)
  
!  flocal = reshape(recvbuf, (/full_i_blocksize,full_j_blocksize,kb/))
!end subroutine scatterfield
