subroutine shapiro(nfilter,f,is,ie,js,je,kdim)
!
! Apply a "horisontal" (dimension spanned by i,j) Shapiro filter to F(:,:) NFILTER times
!
  use mod_mpi
  implicit none
  integer nfilter, is,ie,js,je,kdim
  real, pointer :: f(:,:), f2(:,:)  
  integer if,i,j,k

  allocate(f2(i1:i2,j1:j2))
  
  do if = 1,nfilter
      call tag_ghost(f)
      call update_ghost()
      
      f2 = f
!      do k = 1,kdim
          do j = js+1,je-1
              do i = is,ie
                  if (f(i,j).gt.0.) then
                      if (f(i,j-1).gt.0. .and. f(i,j+1).gt.0. ) then
                          f2(i,j) = 0.25*f(i,j-1) + 0.5*f(i,j) + 0.25*f(i,j+1)
                      elseif (f(i,j-1).gt.0. .and. f(i,j+1).le.0. ) then
                          f2(i,j) = 0.25*f(i,j-1) + 0.75*f(i,j)
                      elseif (f(i,j-1).le.0. .and. f(i,j+1).gt.0. ) then
                          f2(i,j) = 0.25*f(i,j+1) + 0.75*f(i,j)
                      endif
                  endif
              end do
          end do
!      end do

      call tag_ghost(f2)
      call update_ghost()
      
      f = f2
!      do k = 1,kdim
          do j = js,je
              do i = is+1,ie-1
                  if (f(i,j).gt.0.) then
                      if (f(i-1,j).gt.0. .and. f(i+1,j).gt.0. ) then
                          f2(i,j) = 0.25*f(i-1,j) + 0.5*f(i,j) + 0.25*f(i+1,j)
                      elseif (f(i-1,j).gt.0. .and. f(i+1,j).le.0. ) then
                          f2(i,j) = 0.25*f(i-1,j) + 0.75*f(i,j)
                      elseif (f(i-1,j).le.0. .and. f(i+1,j).gt.0. ) then
                          f2(i,j) = 0.25*f(i+1,j) + 0.75*f(i,j)
                      endif
                  endif
              end do
 !         end do
      end do
      f = f2
  end do

  deallocate(f2)
  
  call tag_ghost(f)
  call update_ghost()
  
end subroutine shapiro
