SUBROUTINE SMAGOR2D
USE STATE
USE CONTROL_PARAMETERS, ONLY : CM2DSPONGE, AM2DSPONGE
!
!   Local variables.
!   AMLIME is an upper limit on AM2D used to avoid instabilities and 
!   unphysical oscillations.
!
INTEGER I,J,DJ
REAL AMLIME,CM2DTMP
AMLIME = 0.5*0.0625*DX**2/(DT/N2D)
AM2D = 0.

DJ=1
IF(JM == 1) DJ=0

DO J=J_EQ_2,JM_MI_1
  DO I=I_EQ_2,IM_MI_1
        IF (FSM(I,J).GT.0.) THEN
            CM2DTMP = CM2D
            IF(CM2DSPONGE) CM2DTMP = SPONGE_CM2D(I,J)
            AM2D(I,J)=CM2DTMP*DX*DY *SQRT( ((UA(I+1,J)-UA(I,J))/DX)**2 &
                 &        +((VA(I,J+DJ)-VA(I,J))/DY)**2 &
                 &     +.5*(.25*(UA(I,J+DJ)+UA(I+1,J+DJ)-UA(I,J-DJ)-UA(I+1,J-DJ))/DY    &
                 &     + .25*(VA(I+1,J)+VA(I+1,J+DJ)-VA(I-1,J)-VA(I-1,J+DJ))/DX)**2)
            IF(AM2DSPONGE) AM2D(I,J) = MAX(SPONGE_CM2D(I,J), AM2D(I,J))
            AM2D(I,J) = MIN(AM2D(I,J),AMLIME)
            AM2D(I,J) = MAX(AM2D(I,J),AM2DMIN)        
        ENDIF
    END DO
END DO
call dump_state("smagor2d")
END
