SUBROUTINE STEPU3D(UBCLIN,VBCLIN,C3U,AX)
  USE STATE
  IMPLICIT NONE
  REAL,dimension(i1:i2,j1:j2,kb):: UBCLIN,VBCLIN,C3U,VU
  REAL,dimension(i1:i2,j1:j2) :: AX
  INTEGER I,J,K
  REAL FAC

  FAC=0.25
  IF(JM == 1) THEN
      FAC=0.5
  END IF

!  Propagate the solution in UBCLIN.
  
!
!Define V*D in U-points.
!
  VU = 0.
  

  DO K = 1,KB-1
     DO J=J_EQ_2,JM_MI_1
        DO I=I_EQ_2,I_EQ_IM
           IF (DUM(I,J).GT.0.) THEN
              IF (DVM(I,J).GT.0.) THEN
                 VU(I,J,K) = VU(I,J,K) + VBCLIN(I,J,K)*DV(I,J)/HVSQR(I,J)
              ENDIF
              IF (DVM(I-1,J).GT.0.) THEN
                 VU(I,J,K) = VU(I,J,K) + VBCLIN(I-1,J,K)*DV(I-1,J)/HVSQR(I-1,J)
              ENDIF
              IF(JM > 1)THEN
                  IF (DVM(I-1,J+1).GT.0.) THEN
                      VU(I,J,K) = VU(I,J,K) + VBCLIN(I-1,J+1,K)*DV(I-1,J+1)/HVSQR(I-1,J+1)
                  ENDIF
                  IF (DVM(I,J+1).GT.0.) THEN
                      VU(I,J,K) = VU(I,J,K) + VBCLIN(I,J+1,K)*DV(I,J+1)/HVSQR(I,J+1)
                  ENDIF
              END IF
              VU(I,J,K) = FAC*VU(I,J,K)*HUSQR(I,J)
           ENDIF
        END DO
     END DO
  END DO
!
  DO K = 1,KB-1
     DO J=J_EQ_2,JM_MI_1
        DO I=I_EQ_2,I_EQ_IM
           DELTAU(I,J,K) = COR(I,J)*VU(I,J,K) + DELTAU(I,J,K) - AX(I,J) 
           DELTAU(I,J,K) = DELTAU(I,J,K) + C3U(I,J,K)
        END DO
     END DO
  END DO

  DO J=J_EQ_2,JM_MI_1
     DO I=I_EQ_2,I_EQ_IM
        IF (DUM(I,J).NE.0.) THEN
           DO K = 1,KB-1
              UBCLIN(I,J,K) = UBCLIN(I,J,K) + DT*DELTAU(I,J,K)/DU(I,J)
              U(I,J,K) = UBCLIN(I,J,K) + UA(I,J)              
           END DO
        ENDIF
     END DO
  END DO

  call dump_state('stepu3d')
END SUBROUTINE STEPU3D
   
