SUBROUTINE STEPV3D(UBCLIN,VBCLIN,C3V,AY)
  USE STATE
  IMPLICIT NONE
  REAL,dimension(i1:i2,j1:j2,kb):: UBCLIN,VBCLIN,C3V,UV
  REAL,dimension(i1:i2,j1:j2) :: AY
  INTEGER I,J,K
  REAL FAC
  
  FAC=0.25
  IF(JM==1)FAC=0.5
!
!Define U*D in V-points.
!
  UV = 0.

  DO K = 1,KB-1
     DO J=J_EQ_2,J_EQ_JM
        DO I=I_EQ_2,IM_MI_1
           IF (DVM(I,J).NE.0.) THEN
              IF (DUM(I+1,J).NE.0.) THEN
                 UV(I,J,K) = UBCLIN(I+1,J,K)*DU(I+1,J)/HUSQR(I+1,J)
              ENDIF
              IF (DUM(I,J).NE.0.) THEN
                 UV(I,J,K) = UV(I,J,K) + UBCLIN(I,J,K)*DU(I,J)/HUSQR(I,J)
              ENDIF
              IF(JM > 1)THEN
                  IF (DUM(I+1,J-1).NE.0.) THEN
                      UV(I,J,K) = UV(I,J,K) + UBCLIN(I+1,J-1,K)*DU(I+1,J-1)/HUSQR(I+1,J-1)
                  ENDIF
                  IF (DUM(I,J-1).NE.0.) THEN
                      UV(I,J,K) = UV(I,J,K) + UBCLIN(I,J-1,K)*DU(I,J-1)/HUSQR(I,J-1)
                  ENDIF
              END IF
              UV(I,J,K) = FAC*UV(I,J,K)*HVSQR(I,J)
           ENDIF
        END DO
     END DO
  END DO
!
!Then step forward the 3-D V-field
!
  DO K = 1,KB-1
     DO J=J_EQ_2,J_EQ_JM
        DO I=I_EQ_2,IM_MI_1
           DELTAV(I,J,K) = -COR(I,J)*UV(I,J,K)+DELTAV(I,J,K)-AY(I,J) 
           DELTAV(I,J,K) = DELTAV(I,J,K) + C3V(I,J,K)
        END DO
     END DO
  END DO

  DO J=J_EQ_2,J_EQ_JM
     DO I=I_EQ_2,IM_MI_1
        IF (DVM(I,J).NE.0.) THEN
           DO K = 1,KB-1
              VBCLIN(I,J,K) = VBCLIN(I,J,K) + DT*DELTAV(I,J,K)/DV(I,J)
              V(I,J,K) = VBCLIN(I,J,K) + VA(I,J)              
           END DO
        ENDIF
     END DO
 END DO
 
 call dump_state('stepv3d')
END SUBROUTINE STEPV3D
