SUBROUTINE SUPERBEEW3D
!
!***ROUTINES CALLED-NONE
!***END PROLOGUE
!
!   Global variables.
!
  USE STATE
  USE MOD_BOUND
  IMPLICIT NONE
!
!   Local variables.
!
  REAL :: XFLUXUP,YFLUXUP,ZFLUXUP
  REAL :: XFLUXLW,YFLUXLW,ZFLUXLW
  REAL, DIMENSION(:,:,:), POINTER :: XFLUX,YFLUX,ZFLUX
  REAL :: XFLUXD, YFLUXD
  REAL AREA,NETFLUX,VOLUME,VOLUMEP,LAMBDAX,LAMBDAY
  REAL R,PHIR,NUMER,DENUM,EPSILON,AREAT,AREATU,AREATV,AREATW,UP
  INTEGER I,J,K,NSIG,gi,gj,iw,dj
  logical inblock
!
  dj=1
  if(jm==1)dj=0

  ALLOCATE(XFLUX(I1:I2,J1:J2,KB), YFLUX(I1:I2,J1:J2,KB), ZFLUX(I1:I2,J1:J2,KB))
 

  LAMBDAX = DT/DX
  LAMBDAY = DT/DY
  EPSILON = 1.E-10
!
!   Define FIELD(KB) = FIELD(KB-1)
!
W(:,:,KB) = 0.
W(:,:,1) = 0.

call tag_ghost(w)
call tag_ghost(wadv)
call update_ghost

!
!   First advection in X-direction.
!
  XFLUX = 0.
  XFLUXUP = 0.
  XFLUXLW = 0.
!
  YFLUX = 0.
  YFLUXUP = 0.
  YFLUXLW = 0.
!
  DO K = 2,KB-1
      DO J = 1,J_EQ_JM
          DO I = i_eq_2,i_eq_IM
              gi = block%fi + i - 1        
              IF (DUM(I,J).NE.0.) THEN
                  UP = 0.5*(UADV(I,J,K-1)+UADV(I,J,K))
                  AREAT = DY*DU(I,J)*DZZ(K-1)
                  AREATU = AREAT*UP
                  XFLUXD = AM(I,J,K)*AREAT*(W(I,J,K)-W(I-1,J,K))/DX
                  IF (UP.GE.0.) THEN
                      XFLUXUP = AREATU*W(I-1,J,K)
                      NSIG = 1
                  ELSE
                      XFLUXUP = AREATU*W(I,J,K)
                      NSIG = -1
                  ENDIF
                  XFLUXLW = 0.5*AREATU*(W(I,J,K)+W(I-1,J,K)) - &
                       & 0.5*LAMBDAX*UP**2*(W(I,J,K)-W(I-1,J,K))*AREAT
                  IF ((gI.GT.2 .AND. gI.LE.IM-1) .or. periodic_ew) THEN
                      NUMER = (ABS(0.5*(UADV(I-NSIG,J,K-1)+UADV(I-NSIG,J,K))) - &
                           &   LAMBDAX*(0.5*(UADV(I-NSIG,J,K-1)+UADV(I-NSIG,J,K)))**2)*  &
                           &         DY*(DU(I-NSIG,J)*DZZ(K)*(W(I-NSIG,J,K)-W(I-1-NSIG,J,K)))
                      DENUM = (ABS(UP) - LAMBDAX*UP**2)*  &
                           &         DY*(DU(I,J)*DZZ(K)*(W(I,J,K)-W(I-1,J,K)))
                      IF (ABS(DENUM).GT.EPSILON) THEN
                          R = NUMER/DENUM
                          PHIR = MAX(0., MIN(2.*R,1.) , MIN(R,2.))
                      ELSE 
                          PHIR = 0.
                      ENDIF
                  ELSE
                      PHIR = 0.
                  ENDIF
                  XFLUX(I,J,K) = XFLUXUP + PHIR*(XFLUXLW-XFLUXUP)
                  XFLUX(I,J,K) = XFLUX(I,J,K) - XFLUXD
              ENDIF
          END DO
      END DO
  END DO
!
! 
  IF(JM > 1)THEN
!  Fluxes in Y-direction
!
  DO K = 2,KB-1
      DO J = J_EQ_2,J_EQ_JM
          gj = block%fj + j - 1
          DO I = 1,I_EQ_IM
              IF (DVM(I,J).NE.0.) THEN
                  UP = 0.5*(VADV(I,J,K-1)+VADV(I,J,K))
                  AREAT = DX*DV(I,J)*DZZ(K-1)
                  AREATV = AREAT*UP
                  YFLUXD = AM(I,J,K)*AREAT*(W(I,J,K)-W(I,J-1,K))/DY
                  IF (UP.GE.0.) THEN
                      YFLUXUP = AREATV*W(I,J-1,K)
                      NSIG = 1
                  ELSE
                      YFLUXUP = AREATV*W(I,J,K)
                      NSIG = -1
                  ENDIF
                  YFLUXLW = 0.5*AREATV*(W(I,J,K)+W(I,J-1,K)) - &
                            0.5*LAMBDAY*UP**2*(W(I,J,K)-W(I,J-1,K))*AREAT
                  IF (gj.GT.2 .AND. gj.LE.JM-1) THEN
                      NUMER = (ABS(0.5*(VADV(I,J-NSIG,K-1)+VADV(I,J-NSIG,K))) - &
                           &   LAMBDAY*(0.5*(VADV(I,J-NSIG,K-1)+UADV(I,J-NSIG,K)))**2)*  &
                           &         DX*(DV(I,J-NSIG)*DZZ(K)*(W(I,J-NSIG,K)-W(I,J-1-NSIG,K)))
                      DENUM = (ABS(UP) - LAMBDAY*UP**2)*  &
                           &         DX*(DV(I,J)*DZZ(K)*(W(I,J,K)-W(I,J-1,K)))
                      IF (ABS(DENUM).GT.EPSILON) THEN
                          R = NUMER/DENUM
                          PHIR = MAX(0., MIN(2.*R,1.) , MIN(R,2.))
                      ELSE 
                          PHIR = 0.
                      ENDIF
                  ELSE
                      PHIR = 0.
                  ENDIF
                  YFLUX(I,J,K) = YFLUXUP + PHIR*(YFLUXLW-YFLUXUP)
                  YFLUX(I,J,K) = YFLUX(I,J,K) - YFLUXD
              ENDIF
          END DO
      END DO
  END DO
  
  END IF
!
!   Compute (d(F*W)/d(SIGMA))*DX*DY in all internal points.
!
  ZFLUX = 0.
  ZFLUXUP = 0.
  ZFLUXLW = 0.
  AREA = DX*DY
  
!DO K = 1,KB-1
DO K = 2,KB-2
  DO J = 1,J_EQ_JM
    DO I = i_eq_2,IM_mi_1
              IF(FSM(I,J).NE.0.) THEN
                  UP = 0.5*(WADV(I,J,K+1)+WADV(I,J,K))
                  AREATW = AREA*UP
                  IF (UP.GE.0.) THEN
                      ZFLUXUP = AREATW*W(I,J,K+1)
                      NSIG = -1
                  ELSE
                      ZFLUXUP = AREATW*W(I,J,K)
                      NSIG = 1
                  ENDIF
                  ZFLUXLW = AREATW*0.5*(W(I,J,K)+W(I,J,K+1)) - &
                       &  0.5*AREA*DT*UP**2*(W(I,J,K)-W(I,J,K+1))/(DZ(K)*D(I,J))
                  IF ( K.GE.2 .AND. K.LE.KB-2) THEN
                      NUMER = (ABS(0.5*(WADV(I,J,K-NSIG)+WADV(I,J,K+1-NSIG))) - &
                           &         (DT/(DZ(K-NSIG)*D(I,J)))*(0.5*(WADV(I,J,K-NSIG)+WADV(I,J,K+1-NSIG)))**2)*  &
                           &         (W(I,J,K-NSIG)-W(I,J,K+1-NSIG))
                      DENUM = (ABS(UP) - (DT/(DZ(K)*D(I,J)))*UP**2)*  &
                           &         (W(I,J,K)-W(I,J,K+1))
                      IF (ABS(DENUM).GT.EPSILON) THEN
                          R = NUMER/DENUM
                          PHIR = MAX(0., MIN(2.*R,1.) , MIN(R,2.))
                      ELSE
                          PHIR = 0.
                      ENDIF
                  ELSE
                      PHIR = 0.
                  ENDIF
!
                  ZFLUX(I,J,K) = ZFLUXUP + PHIR*(ZFLUXLW-ZFLUXUP)
              ENDIF
          END DO
      END DO
  END DO
!
!  If UPWELL, then also specify a flux through the sea bed.
!
  IF (UPWELL) THEN
      DO IW = 1,NUMWELL
          I=IWELL(IW) ;  J=JWELL(IW)
          CALL GLOBALIND2LOCAL(I,J,INBLOCK)
          IF(INBLOCK) THEN      
              ZFLUX(I,J,KB) = FWELL(IW)*FWELL(IW)/AREA
          end if
      END DO
  ENDIF

!
!   Take a step to timestep n+1.
!
  call tag_ghost(xflux, sides=east, width=1)
  call tag_ghost(yflux, sides=north, width=1)  
  call update_ghost
  
  DO K = 2,KB-1
      DO J = J_EQ_2,JM_MI_1
          DO I =i_eq_2,IM_mi_1
              IF (FSM(I,J).GT.0.0) THEN
                  NETFLUX = (ZFLUX(I,J,K-1)-ZFLUX(I,J,K)) + (XFLUX(I+1,J,K) - XFLUX(I,J,K)) + &
                       &  (YFLUX(I,J+dj,K) - YFLUX(I,J,K)) 
                  VOLUME = DX*DY*DZZ(K-1)*(H(I,J)+ETA(I,J))
                  VOLUMEP = DX*DY*DZZ(K-1)*(H(I,J)+ETAP(I,J))
                  W(I,J,K) = (W(I,J,K)*VOLUMEP - DT*NETFLUX)/VOLUME

              ENDIF
          END DO
      END DO
  END DO

call dump_state('superbeew3D')  
DEALLOCATE(XFLUX, YFLUX, ZFLUX)

END SUBROUTINE SUPERBEEW3D



