SUBROUTINE UPDATEDD
USE STATE
IMPLICIT NONE
INTEGER I,J,K
!
! UPDATEDD updates the Dynamic Depth fields
! D,DU,DV,DDZ,DUDZ and DVDZ
! after ETA is updated in each time step.
!
call tag_ghost(eta)
call update_ghost

do j=1,j_eq_jm
  do i=1,i_eq_im
    D(i,j) = FSM(i,j)*(H(i,j)+ETA(i,j))
  end do
end do

DO J=1,J_EQ_JM
    DO I=I_EQ_2,I_EQ_IM
        DU(I,J)=DUM(I,J)*(HU(I,J)+0.5*(ETA(I,J)+ETA(I-1,J)))
    END DO
END DO
IF(BLOCK%IBN==1 .and. .not. PERIODIC_EW) DU(1,:) = DUM(1,:)*(HU(1,:)+ETA(1,:))

IF(JM>1)THEN
    DO J=J_EQ_2,J_EQ_JM
        DO I=1,I_EQ_IM
            DV(I,J)=DVM(I,J)*(HV(I,J)+0.5*(ETA(I,J)+ETA(I,J-1)))
        END DO
    END DO
ELSE
    DO J=J_EQ_2,J_EQ_JM
        DO I=1,I_EQ_IM
            DV(I,J)=DVM(I,J)*(HV(I,J)+ETA(I,J))
        END DO
    END DO
END IF    
IF( BLOCK%JBN==1 ) DV(:,1) = DVM(:,1)*(HV(:,1)+ETA(:,1))

DO K = 1,KB-1
  DO J = 1,j_eq_JM
    DO I = 1,i_eq_IM
      DDZ(I,J,K) = DZ(K)*D(I,J)
      DUDZ(I,J,K) = DZ(K)*DU(I,J)
      DVDZ(I,J,K) = DZ(K)*DV(I,J)
    END DO
  END DO
END DO
CALL DUMP_STATE("updatedd")
END
