SUBROUTINE WINDFORCING
!
!  WINDFORCING estimates the wind stresses WUSURF and WVSURF from
!  windspeeds 10m above the sea surface
!
!  PATM may also be redefined in WINDFORCING
!
  USE MOD_BOUND
  USE QMPI
  IMPLICIT NONE

  SELECT CASE(WIND_TYPE)
  CASE(1)
! spatially uniform wind with given direction, strength...
      CALL WIND1()
      
  CASE(2)
! idealized passing low pressure
      CALL WIND2()
      
  CASE(3,4,5,6)
! wind is read from file in "get_and_apply_forcing"
      
  CASE DEFAULT
      WRITE(*,*)'windforcing.f90 error, value of wind_type is unknown; ',WIND_TYPE
      CALL ABORT()
  END SELECT
END SUBROUTINE WINDFORCING
