SUBROUTINE WREAL
  USE STATE
  IMPLICIT NONE
!***BEGIN PROLOGUE WREAL
!***REVISION DATE 300196
!
!***AUTHOR
!
!     Revised by 
!
!            Jarle Berntsen, Department of Mathematics
!
!***PURPOSE WREAL computes the real vertical velocity, WR.
!
!***ROUTINES CALLED NONE
!***END PROLOGUE WREAL
!
  REAL, DIMENSION(I1:I2,J1:J2) :: ZLEV
!
!   Local variables.
!
  INTEGER I,J,K,DJ
  REAL DXR,DYT,DTI
!
  DJ=1
  IF(JM == 1) DJ=0 
!
  DXR = 1./DX
  DYT = 1./DY
  DTI = 1./DT
!
  WR = 0.
!
!   Adjust WR by taking into account the
!   gradient of the sigma-surfaces.
!
  DO K = 1,KB-1
      DO J=J1,J2
          DO I=I1,I2
              ZLEV(I,J)=ZZ(K)*D(I,J) + ETA(I,J)
          END DO
      END DO
!
      DO J = J_eq_2,JM_mi_1
          DO I = I_eq_2,IM_mi_1
              WR(I,J,K)=0.5*(W(I,J,K)+W(I,J,K+1)) + 0.5* &
                   &   ( U(I+1,J,K)*(ZLEV(I+1,J)-ZLEV(I,J))*DXR  + &
                   &     U(I,J,K)*(ZLEV(I,J)-ZLEV(I-1,J))*DXR    + &
                   &     V(I,J+DJ,K)*(ZLEV(I,J+DJ)-ZLEV(I,J))*DYT  + &
                   &     V(I,J,K)*(ZLEV(I,J)-ZLEV(I,J-DJ))*DYT  ) + &
                   &    (1.+ZZ(K))*(ETA(I,J)-ETAP(I,J))*DTI
              WR(I,J,K) = WR(I,J,K)*FSM(I,J)
          END DO
      END DO
  END DO

  CALL DUMP_STATE("wreal")
END
